// Generated by CoffeeScript 1.10.0
(function() {
  var Settings, context_height, current_filename, d, directory_url, document_modified, ed, editor_refresh_pending, editor_url, el, header_height, in_workspace, new_file, save, saveDocument, setEditorHeight, setHeights, syntax_highlighter, workspace_url;

  d = document;

  Settings = Symphony.Extensions.Workspacer['settings'];

  el = null;

  ed = {};

  header_height = null;

  context_height = null;

  workspace_url = null;

  editor_url = null;

  directory_url = null;

  in_workspace = false;

  current_filename = null;

  new_file = false;

  document_modified = false;

  syntax_highlighter = null;

  editor_refresh_pending = false;

  setEditorHeight = function() {
    return $(ed.OUTER).height($(window).height() - header_height - context_height - 106 + $(window).scrollTop());
  };

  setHeights = function() {
    header_height = $(el.header).height() + $(el.nav).height();
    context_height = $(el.context).height();
    $(el.wrapper).height($(window).height() + header_height).css('overflow', 'hidden');
    $(ed.OUTER).css('overflow', 'hidden');
    return setEditorHeight();
  };

  save = function() {
    var name;
    name = !current_filename ? prompt("File name:") : filename;
    if (name) {
      return saveDocument(input);
    }
  };

  saveDocument = function(new_filename) {
    if (!current_filename && !new_filename) {
      if (!(new_filename = prompt("File name:"))) {
        return;
      }
    }
    return $.ajax({
      'type': 'POST',
      'url': Symphony.Context.get('symphony') + '/extension/workspacer/ajax/' + Symphony.Context.get('env')['0'] + '/',
      'data': {
        'xsrf': $('input[name="xsrf"]').val(),
        'action[save]': '1',
        'fields[dir_path]': $('#dir_path').val(),
        'fields[dir_path_encoded]': $('#dir_path_encoded').val(),
        'fields[current_filename]': current_filename,
        'fields[new_filename]': new_filename,
        'fields[body]': ed.MAIN.contentWindow.getText()
      },
      'dataType': 'json',
      'error': function(xhr, msg, error) {
        return alert(error + " - " + msg);
      },
      'success': function(data) {
        if (data.new_filename) {
          current_filename = data.new_filename;
          $(el.subheading).text(current_filename);
          $('title').html(current_filename + " &ndash; Workspace &ndash; Symphony");
          history.replaceState({
            'a': 'b'
          }, '', Symphony.Context.get('symphony') + '/workspace/editor/' + data.new_path_encoded);
          if ($(el.actions).hasClass('new')) {
            $(el.actions).removeClass('new').addClass('edit');
          }
          el.iframe.setHighlighter(current_filename);
        }
        $('div.notifier').trigger('attach.notify', [data.alert_msg, data.alert_type]);
        if ($(el.body).hasClass('new')) {
          $(el.body).removeClass('new').addClass('edit');
        }
        if (data.alert_type === 'error') {
          $(window).scrollTop(0);
        }
        return setHeights();
      }
    });
  };

  $(document).ready(function() {
    el = Symphony.Elements;
    el.subheading = $('#symphony-subheading');
    el.filename = $('#filename');
    el.form = $(el.contents).find('form')[0];
    el.iframe = $(el.form).find('iframe')[0].contentWindow;
    current_filename = $(el.form).data('filename');
    el.actions = $(el.form).find('div.actions');
    header_height = $(el.header).height();
    context_height = $(el.context).height();
    in_workspace = !($(el.body).data('0') === 'template' || $(el.body).hasClass('template'));
    if (in_workspace) {
      directory_url = Symphony.Context.get('symphony');
      +Symphony.Context.get('env')['page-namespace'] + '/' + $(el.form).find('input[name="fields[dir_path_encoded]"]').attr('value');
    }
    ed.OUTER = $('#editor')[0];
    ed.LINE_NUMBERS = $('#editor-line-numbers')[0];
    ed.MAIN = $('#editor-main')[0];
    $(window).resize(function(event) {
      return setHeights();
    });
    $(document).on('editor-focusin', function(event) {
      if (!($(ed.OUTER).hasClass('focus'))) {
        return $(ed.OUTER).addClass('focus');
      }
    }).on('editor-focusout', function(event) {
      if ($(ed.OUTER).hasClass('focus')) {
        return $(ed.OUTER).removeClass('focus');
      }
    }).on('editor-scrolltop', function(event, top) {
      return ed.LINE_NUMBERS.scrollTop = top;
    }).on('save-doc', function(event) {
      return saveDocument();
    }).scroll(function(event) {
      return setEditorHeight();
    });
    $(ed.LINE_NUMBERS).scrollTop(0).mousedown(function(event) {
      event.preventDefault();
      return ed.MAIN.focus();
    });
    $('input[name="action[create]"]').click(function(event) {
      return saveDocument();
    });
    $('input[name="action[save]"]').click(function(event) {
      return saveDocument();
    });
    $('input[name="action[save-as]"]').click(function(event) {
      var new_filename;
      if (new_filename = prompt("Save as")) {
        return saveDocument(new_filename);
      }
    });
    return Symphony.Utilities.requestAnimationFrame(setHeights);
  });

  window.displayLineNumbers = function(num_lines) {
    var i, j, l, ref;
    l = '';
    for (i = j = 1, ref = num_lines; 1 <= ref ? j <= ref : j >= ref; i = 1 <= ref ? ++j : --j) {
      l += i + "<br>";
    }
    return $(ed.LINE_NUMBERS).html(l + '<br><br>');
  };

}).call(this);
